/**
 * @author Jorge Leonardo Suárez
 * complemetado por José Mauricio Aizaga
 */
 var completar_definiciones = function(contenedor, opciones, preguntas){
    /*Esta función crea la estructura html de las preguntas a realizar.
    Las preguntas deben venir con el espacio para poner un select de la siguiente forma:

    pregunas = [
        '{{option}}: Utiliza el estándar IEEE 802.15.',
    ]

    */
    var select = '<span><select class="cs-select cs-skin-slide"></select></span>';
    for (var i = 0; i < preguntas.length; i++) {
        var dt = '<dt>' + preguntas[i].replace(/{{option}}/g, select) + '</dt><dd></dd>';
        $(contenedor + " .listas-ordenadas").append(dt);
    };
    completar(contenedor, opciones);
}

var completar = function(contenedor, palabras) {
    //console.log('esto pasa');
    /**
     * Estado de la actividad. Indica si esta ya fue calificada o no.
     * @type {Boolean}
     */
    var calificado = false;
    var opciones = palabras;
    /**
     * Desordena un array de valores
     * @param  {Array} array
     * @return {Array}
     */
    function shuffle(array) {
        var currentIndex = array.length,
            temporaryValue, randomIndex;
        // While there remain elements to shuffle...
        while (0 !== currentIndex) {
            // Pick a remaining element...
            randomIndex = Math.floor(Math.random() * currentIndex);
            currentIndex -= 1;
            // And swap it with the current element.
            temporaryValue = array[currentIndex];
            array[currentIndex] = array[randomIndex];
            array[randomIndex] = temporaryValue;
        }
        return array;
    }

    /**
     * Califica una actividad de completar textos
     * @param  {Event} event
     * @return {void}
     */
    function calificar(event) {
        //console.log('esto pasa');
        $(contenedor + ' select').each(function(index) {
            var value = opciones[index];
            if ($(this).val() == value) {
                $(this).parent().addClass('correcto').removeClass('incorrecto');
            } else {
                $(this).parent().addClass('incorrecto').removeClass('correcto');
            }
        });
    }
    /**
     * Inicia los eventos de la actividad
     * @return {null}
     */
    //Habilitamos los selects que hay en la actividad
    options = [];
    for(var index in opciones){
        options.push($('<option>').html(opciones[index]).attr('value', opciones[index]));
    }
    //Desordenamos las opciones.
    shuffle(options);
    //options.splice(0,0, $('<option>').html('--').attr('value', '--'));
    //Agregamos nuevamenete las opciones a los select.
    $(contenedor + " select").html(options);
    //Le asignamos valor vacio para que no quede ninguna opcion seleccionada.
    $(contenedor +" select").val('');
    $("#edModal__calificar").on('click', calificar);
    $("#edModal__calificar").on("click", mostrarModalCalificacion);

}